#include <math.h>
#include <iostream.h>
#include <stdio.h>
#include <iomanip.h>

const double ZEROTOL = .000000000001;

double f(double x)
{
  return exp(2*pow(x,2))-1-3*cos(2*x);
//  return sin(pow(x,2))-x-1;
}

int sgn(double n)
{
  if(n==0) return 0;
  else if(n>0) return 1;
  else return -1;
}

inline int zero(double n)
{ return (fabs(n) < ZEROTOL); }

void OutputRoot(double n)
{
  cout << "\n(" << n << ',' << f(n) << ")";
  return;
}

void main()
{
  cout << setprecision(8);

  double a, b, c, fa, fb, fc;
  int nIter;
  cout << "a=";
  cin  >> a;
  cout << "b=";
  cin  >> b;
  cout << "Iterations=";
  cin  >> nIter;

  fa=f(a);
  fb=f(b);

  if(fa==0)
  { OutputRoot(a); return; }

  if(fb==0)
  { OutputRoot(b); return; }

  if(sgn(fa)*sgn(fb) > 0)
  { cout << "Error: sign(f(a)) == sign(f(b))"; return; }

  for(int i=1;i<=nIter;i++)
  {
    c=a+(b-a)/2;
    fc=f(c);
    if(zero(fc))
    {
      OutputRoot(c);
      return;
    }
    else
    {
      if(sgn(fa)*sgn(fc)>0)  //if sgn(fa)==sgn(fc) => a=c
      {
	a=c;
	fa=f(a);
      }
      else
	b=c;
    }
    cout << "Iteration " << i << ": (" << c << ',' << fc << ")\n";
  }
}